<template>
<v-container class="d-print-none" v-if="pwa.hasUpdate">
  <v-alert
    prominent
    type="info"
    border="bottom"
    colored-border
    :icon="mdiCellphoneArrowDown"
    >
    <v-row align="center">
      <v-col class="grow">
        Есть обновление у сайта
      </v-col>
      <v-col class="shrink">
        <v-btn
          :loading="loading"
          color="green white--text"
          @click="pwaUpdate"
          >
          <!-- <v-icon>{{mdiCellphoneArrowDown}}</v-icon> -->
          Обновить
        </v-btn>
      </v-col>
    </v-row>
  </v-alert>

  <v-snackbar
    v-model="snackbar"
    >
    {{ text }}

    <template v-slot:action="{ attrs }">
      <v-btn
        color="red"
        text
        v-bind="attrs"
        @click="snackbar = false"
        >
        Close
      </v-btn>
    </template>
  </v-snackbar>
</v-container>
</template>

<script>
import { mapState } from 'vuex';
import {
  // mdiContacts,
  mdiCellphoneArrowDown,
} from '@mdi/js';

export default {
  computed: {
    ...mapState([
      'pwa',
      // 'user',
      // 'repetitor',
    ]),
  },
  data: () => ({
    mdiCellphoneArrowDown,

    text: '',
    snackbar: false,
    loading: false,
  }),
  methods: {
    pwaUpdate() {
      this.loading = true;
      const newServiceWorker = this.$store.state.pwa.newWorker;

      if (newServiceWorker) {
        newServiceWorker.postMessage({ action: 'skipWaiting' });
      } else {
        this.text = 'Error: no new service worker';
        this.snackbar = true;
        this.loading = false;
      }
      // We can't do document.location.reload() here because a service
      // worker may not have finished skipWaiting(). A blank screen can
      // appear.
    },
  },
};
</script>
